#include <cstdlib>
#include <iostream>
#include <stdio.h>
#include <windows.h>
#include <string>
#include <conio.h>
#include "serial.hpp"
#include "motor.hpp"
#include "sonar.hpp"
#include "sensor.hpp"


Serial bluetooth;
Motor wheel1 = Motor(1,&bluetooth);
Motor wheel2 = Motor(2,&bluetooth);

Sonar sonar = Sonar(0,&bluetooth);   //ultrazvuni senzor je na portu 1
Sensor touch = Sensor(1,&bluetooth); //tipkalo je na portu 2

using namespace std;

int main(int argc, char *argv[]){
    FILE *fp;  //file pointer
    
    if(bluetooth.connect("COM9")){
        int i = 1;
        float distance;
        int zapis;
        cout << "Connection OK!" << endl;
        sonar.setup();
       
        touch.type_and_mode(TOUCH,BOOL_MODE); //inicijaliziranje tipkala

        do{
            if ((fp = fopen("myfile", "r+")) ==NULL){  //otvaranje datoteke
                printf("Error opening file\n");  //provjera
                exit(1); 
            }

           distance=sonar.distance();
           cout <<"Udaljenost: "<< distance<<" cm"<<endl;
           
           zapis=distance;
           
           fputc(zapis,fp); //upisi podatako udaljenosti u datoteku
           fclose(fp);  //zatvori datoteku
            
            if (distance < 35){
                wheel1.stop();
                wheel2.stop();
            }
                
            if(touch.read() && i){
                cout <<"tipkalo je ukljuceno"<<endl;
                i=0;
            }
            
            if(touch.read()==0 && !i){
                cout <<"tipkalo je iskljuceno"<<endl;
                i=1;
            }
                
		
                                             

       } while(1);

       bluetooth.disconnect();
    }

    else{
     cout << "Connection not OK!" << endl;
    }
    system("PAUSE");

    return EXIT_SUCCESS;
}
