#include <iostream>
#include "io_8574.hpp"
#include <stdio.h>
#include <time.h>
#include <string>
#include <stdlib.h>
using namespace std;

    
    IO_8574::IO_8574(){
    }
    
    IO_8574::IO_8574(int port,char adress, Serial *cp){
        sensor = I2C(port, cp);
        sensor_adress = adress;
    }
    
    int IO_8574::setup(){
        sensor.sensor_type(LOWSPEED);
        Sleep(500);
        write(0x00);
        write(0x00);
        write(0x00);
        return 1;
    }
    
    int IO_8574::read(){
        char *answer;
        char command[1];
        command[0]=sensor_adress;
        sensor.write(&command[0], 1, 1);
        if(sensor.wait_ans(1)){
            answer=sensor.read();
            return  answer[1] & 0xff; //returns unsigned value                       
        }
        return -1;
    }
    
    int IO_8574::write(char pins){
        char command[2];
        command[0] = sensor_adress;
        command[1] = pins;
        sensor.write(&command[0], 2, 0);
        return  sensor.wait_ans(0); 
    }
    
    
